function [STRAINS SDEL ITIMES FULLSTRAIN LASTITER MEANS]=gen_pivotMDS_strains_multi(D,numsamples,eps)

    startoff = 5; % number of iters before doing GPR
    numsamples_gpr = 5; % number of samples to use in training the GPR
    
    incr_amount = ceil(log10(size(D,1)));
    my_perm = randperm(size(D,1));
    k = 1;
    K = my_perm(1);
    upper_loop_bound = size(D,1);
%     if nargin > 1
%         upper_loop_bound = maxK;
%     end
    STRAINS = zeros(numsamples,length(incr_amount:incr_amount:upper_loop_bound));
    SDEL = zeros(numsamples,length(incr_amount:incr_amount:upper_loop_bound));
    ITIMES = zeros(1,length(incr_amount:incr_amount:upper_loop_bound));
    FULLSTRAIN = zeros(1,length(incr_amount:incr_amount:upper_loop_bound));
    MEANS = zeros(1,length(incr_amount:incr_amount:upper_loop_bound));
    Sold = 0;
    for i = incr_amount:incr_amount:upper_loop_bound
        
        %[X V S] = pivotMDS(D,my_perm(1:i));
%         if( i > incr_amount )
%             [X V S K] = pivotMDS2(D,K,i,X(:,1));
%         else
            tic;
            [X V S K Sprev] = pivotMDS2plus_multi(D,K,i,numsamples);
            ITIMES(k)=toc;
%         end
        I = repmat(K,size(D,1),1);
        I = [I(:) repmat((1:size(D,1))',length(K),1)];
        %STRAINS(k)=sparsestressfun(X(:),D,I);
        STRAINS(:,k)=S;
        SDEL(:,k)=(Sprev-Sold);
        Sold = S;
        
        % GPR
        
        if (k-startoff) == numsamples_gpr
            
            M = median(abs(SDEL./STRAINS)',2);
            meanfunc=[];
            hyp1.mean=[];
            covfunc=@covSEiso;
            hyp1.cov = [2 2];
            likfunc=@likGauss;
            hyp1.lik=log(0.1);
            hyp1=minimize(hyp1,@gp,-100,@infExact,meanfunc,covfunc,likfunc,(startoff:(numsamples_gpr+startoff))',M(startoff:(numsamples_gpr+startoff)));
        end
        if (k-startoff) > numsamples_gpr
            
            M = median(abs(SDEL(:,1:k)./STRAINS(:,1:k))',2);            
            [m s2]=gp(hyp1,@infExact,meanfunc,covfunc,likfunc,(startoff:length(M))',M(startoff:end),(startoff:length(M))');
            MEANS(k)=m(end);
            fprintf('%f\n',m(end));
            FULLSTRAIN(k)=fullstrain( X, D );
            if m(end) <= eps
                LASTITER = k;
%                 if nargout > 3
% 
%                     FULLSTRAIN = fullstrain( X, D );
%                 end
                return;
            end            
        end
        
        k = k  + 1;
    end
    
    LASTITER=length(STRAINS);
    
    if nargout > 3

        FULLSTRAIN = fullstrain( X, D );
    end
