function [X Dtimes Itimes stresses fullstresses innerstresses innerlocs]=glint_w_smacof(D,X,eps)

    use_fancy = 0;
    if sum(sum(isnan(D)))
        
        use_fancy = 1;
    end

    converged = 0;
    N = size(D,1);
    k = 2*ceil(log10(N));
    PAT = getrandompatternNAN( N, k, D ); 
    P = randperm(N);
    
    iters = 0;
    Dtimes = [k];
    Itimes = [];
    stresses = [];
    fullstresses = [];
    innerstresses = [];
    innerlocs = [];
    
    while ~converged
        
        iters = iters + 1;
        tic;
        if iters == 1
            [X t s] = sparsesmacof(X,D,PAT,1e-3,100);
        else
            [X t s sprev] = sparsesmacofplus(X,D,PAT,PATprev,1e-3,100);
        end
        Itimes(iters)=toc();
        stresses(iters)=s(end);
        innerstresses(length(innerstresses)+1:length(innerstresses)+length(s))=s;
        innerlocs(iters)=length(innerstresses);
        if nargout > 4
            
            if use_fancy
                [row col]=find(~isnan(D));
                I=[row col];
                fullstresses(iters)=sparsestressfun(X(:),D,I);
            else
                fullstresses(iters)=normstressfun(X(:),D);
            end
        end
        if iters > 1
            
            converged = abs((sprev - sold)/sold)<eps;
            fprintf('converged = %d, sold = %f, s = %f,delta=%f\n',converged,sold, sprev,abs((sprev-sold)/sold));
        end
        sold = s;
        PATprev = PAT;
%         PAT = glimproverandompattern(PAT,N,k);
        PAT = glimmer_patternNAN(PAT,P,k,D);
        Dtimes(iters+1)=k;
    end

end