%
% like pivotMDS but using a "choose farthest" pivot selection process
%
function [X d S K]=pivotMDS2plus_manual(D,k,pivotnum)

    opts.disp = 0;

    if size(k,2) == 1
        K=zeros(1,pivotnum);
        K(1)=k;
    else
        K = k;
    end
    for i = (size(k,2)+1):pivotnum
        K(i)=pivotMDSfarthest(D,K(1:(i-1)));
    end
    
    [C DELTA2]=doubleCenter2(D(:,K));
    [V,d]=eigs(C'*C,2,'lm',opts);    

    X=C*V;
    Df = subinner(X,K);
    Qf = subinner(C,K);
    S = sum(sum((Qf-Df).^2))/sum(sum(Qf.^2));            
end
    
