%
%   perform smacof for a given distance matrix and a given 2d config until
%
%   convergence to epsilon
function [X stresses]=smacof(X,DELTA,eps,W)
    
    fold = 1e100;
    stresses = [];
    [f g]=stressfun(X(:),DELTA);
    t = 0;
    stresses(t+1)=f;
    fprintf('%d: %f\n', t, f);
    while abs((fold-f)/f) > eps
%     while norm(g) > eps
        t = t + 1;
        fold = f;
        if nargin > 3
            V = -W;
            V(1:size(V,1)+1:numel(V)) = sum(W,2);
            X = X - 0.5*pinv(V)*reshape(g,size(X,1),size(X,2));
            [f g]=stressfun(X(:),DELTA);
            stresses(t+1)=f;
        else
            X(:) = X(:) - (1/(2*size(X,1)))*g;
            [f g]=stressfun(X(:),DELTA);
        end
        fprintf('%d: %f\n', t, f);
    end