%
% d = sparsefulldistance(a,I)
%
% compute n^2 distance matrix d but only those entry pairs specified by I
%
% assumes a is a matrix of coords with rows = dims and cols = pts
%
function d = sparsefulldistance(a,I)
aa=sum(a.*a,1); 
%d = sparse(size(a,2),size(a,2));
Itemp = unique([[I(:,1);I(:,2)] [I(:,2);I(:,1)]],'rows');
%d = sparse(Itemp(:,1),Itemp(:,2),sqrt(arrayfun( @(x,y)((aa(x)+aa(y))-2*dot(a(:,x),a(:,y))),Itemp(:,1),Itemp(:,2))),size(a,2),size(a,2));
%d = sparse(Itemp(:,1),Itemp(:,2),sqrt(arrayfun( @(x,y)((aa(x)+aa(y)-2*a(:,x)'*a(:,y))),Itemp(:,1),Itemp(:,2))),size(a,2),size(a,2));

d = sparse(Itemp(:,1),Itemp(:,2),(sqrt(aa(Itemp(:,1)) + aa(Itemp(:,2)) - 2*(sum(a(:,Itemp(:,1)).*a(:,Itemp(:,2)))))),size(a,2),size(a,2));

% for i = 1:size(I,1)
%     d(I(i,1),I(i,2))=sqrt(abs(aa(I(i,1))+aa(I(i,2))-2*dot(a(:,I(i,1)),a(:,I(i,2)))));
%     d(I(i,2),I(i,1))=d(I(i,1),I(i,2));
% end
